1bcf0df935d66157a5ad66af7516ac5d6bcf12e8
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 this_test=${0##*/}
30 this_test=${this_test%.sh}
31 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
32
33 # if --tee was passed, write the output not only to the terminal, but
34 # additionally to the file test-results/$BASENAME.out, too.
35 case "$GIT_TEST_TEE_STARTED, $* " in
36 done,*)
37         # do not redirect again
38         ;;
39 *' --tee '*|*' --va'*)
40         mkdir -p test-results
41         BASE=test-results/$this_test
42         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
43          echo $? > $BASE.exit) | tee $BASE.out
44         test "$(cat $BASE.exit)" = 0
45         exit
46         ;;
47 esac
48
49 # Save STDOUT to fd 6 and STDERR to fd 7.
50 exec 6>&1 7>&2
51 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
52 BASH_XTRACEFD=7
53 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
54
55 # Keep the original TERM for say_color and test_emacs
56 ORIGINAL_TERM=$TERM
57
58 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
59 # Otherwise use whatever TERM is currently used so that
60 # users' actual TERM environments are being used in tests.
61 case ${TERM-} in
62         '' | dumb | unknown )
63                 SMART_TERM=vt100 ;;
64         *)
65                 SMART_TERM=$TERM ;;
66 esac
67
68 # For repeatability, reset the environment to known value.
69 LANG=C
70 LC_ALL=C
71 PAGER=cat
72 TZ=UTC
73 TERM=dumb
74 export LANG LC_ALL PAGER TERM TZ
75 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
76 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
77       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
78     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
79     exit 1
80 fi
81 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
82 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
83 TEST_GDB=${TEST_GDB:-gdb}
84 TEST_CC=${TEST_CC:-cc}
85 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
86
87 # Protect ourselves from common misconfiguration to export
88 # CDPATH into the environment
89 unset CDPATH
90
91 unset GREP_OPTIONS
92
93 # For emacsclient
94 unset ALTERNATE_EDITOR
95
96 # Each test should start with something like this, after copyright notices:
97 #
98 # test_description='Description of this test...
99 # This test checks if command xyzzy does the right thing...
100 # '
101 # . ./test-lib.sh || exit 1
102
103 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
104                 TERM=$ORIGINAL_TERM &&
105                 export TERM &&
106                 [ -t 1 ] &&
107                 tput bold >/dev/null 2>&1 &&
108                 tput setaf 1 >/dev/null 2>&1 &&
109                 tput sgr0 >/dev/null 2>&1
110         ) &&
111         color=t
112
113 while test "$#" -ne 0
114 do
115         case "$1" in
116         -d|--debug)
117                 debug=t; shift ;;
118         -i|--immediate)
119                 immediate=t; shift ;;
120         -h|--help)
121                 help=t; shift ;;
122         -v|--verbose)
123                 verbose=t; shift ;;
124         -q|--quiet)
125                 quiet=t; shift ;;
126         --with-dashes)
127                 with_dashes=t; shift ;;
128         --no-color)
129                 color=; shift ;;
130         --no-python)
131                 # noop now...
132                 shift ;;
133         --valgrind)
134                 valgrind=t; verbose=t; shift ;;
135         --tee)
136                 shift ;; # was handled already
137         --root=*)
138                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
139                 shift ;;
140         *)
141                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
142         esac
143 done
144
145 if test -n "$debug"; then
146     print_subtest () {
147         printf " %-4s" "[$((test_count - 1))]"
148     }
149 else
150     print_subtest () {
151         true
152     }
153 fi
154
155 if test -n "$color"; then
156         say_color () {
157                 (
158                 TERM=$ORIGINAL_TERM
159                 export TERM
160                 case "$1" in
161                         error) tput bold; tput setaf 1;; # bold red
162                         skip)  tput bold; tput setaf 2;; # bold green
163                         pass)  tput setaf 2;;            # green
164                         info)  tput setaf 3;;            # brown
165                         *) test -n "$quiet" && return;;
166                 esac
167                 shift
168                 printf " "
169                 printf "$@"
170                 tput sgr0
171                 print_subtest
172                 )
173         }
174 else
175         say_color() {
176                 test -z "$1" && test -n "$quiet" && return
177                 shift
178                 printf " "
179                 printf "$@"
180                 print_subtest
181         }
182 fi
183
184 error () {
185         say_color error "error: $*\n"
186         GIT_EXIT_OK=t
187         exit 1
188 }
189
190 say () {
191         say_color info "$*"
192 }
193
194 test "${test_description}" != "" ||
195 error "Test script did not set test_description."
196
197 if test "$help" = "t"
198 then
199         echo "Tests ${test_description}"
200         exit 0
201 fi
202
203 test_description_printed=
204 print_test_description ()
205 {
206         test -z "$test_description_printed" || return 0
207         echo
208         echo $this_test: "Testing ${test_description}"
209         test_description_printed=1
210 }
211 if [ -z "$NOTMUCH_TEST_QUIET" ]
212 then
213         print_test_description
214 fi
215
216 test_failure=0
217 test_count=0
218 test_fixed=0
219 test_broken=0
220 test_success=0
221
222 _exit_common () {
223         code=$?
224         trap - EXIT
225         set +ex
226         rm -rf "$TEST_TMPDIR"
227 }
228
229 trap_exit () {
230         _exit_common
231         if test -n "$GIT_EXIT_OK"
232         then
233                 exit $code
234         else
235                 exec >&6
236                 say_color error '%-6s' FATAL
237                 echo " $test_subtest_name"
238                 echo
239                 echo "Unexpected exit while executing $0. Exit code $code."
240                 exit 1
241         fi
242 }
243
244 trap_signal () {
245         _exit_common
246         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
247         exit $code
248 }
249
250 die () {
251         _exit_common
252         exec >&6
253         say_color error '%-6s' FATAL
254         echo " $*"
255         echo
256         echo "Unexpected exit while executing $0."
257         exit 1
258 }
259
260 GIT_EXIT_OK=
261 # Note: TEST_TMPDIR *NOT* exported!
262 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
263 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
264 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
265 trap 'trap_exit' EXIT
266 trap 'trap_signal' HUP INT TERM
267
268 # Generate a new message in the mail directory, with a unique message
269 # ID and subject. The message is not added to the index.
270 #
271 # After this function returns, the filename of the generated message
272 # is available as $gen_msg_filename and the message ID is available as
273 # $gen_msg_id .
274 #
275 # This function supports named parameters with the bash syntax for
276 # assigning a value to an associative array ([name]=value). The
277 # supported parameters are:
278 #
279 #  [dir]=directory/of/choice
280 #
281 #       Generate the message in directory 'directory/of/choice' within
282 #       the mail store. The directory will be created if necessary.
283 #
284 #  [filename]=name
285 #
286 #       Store the message in file 'name'. The default is to store it
287 #       in 'msg-<count>', where <count> is three-digit number of the
288 #       message.
289 #
290 #  [body]=text
291 #
292 #       Text to use as the body of the email message
293 #
294 #  '[from]="Some User <user@example.com>"'
295 #  '[to]="Some User <user@example.com>"'
296 #  '[subject]="Subject of email message"'
297 #  '[date]="RFC 822 Date"'
298 #
299 #       Values for email headers. If not provided, default values will
300 #       be generated instead.
301 #
302 #  '[cc]="Some User <user@example.com>"'
303 #  [reply-to]=some-address
304 #  [in-reply-to]=<message-id>
305 #  [references]=<message-id>
306 #  [content-type]=content-type-specification
307 #  '[header]=full header line, including keyword'
308 #
309 #       Additional values for email headers. If these are not provided
310 #       then the relevant headers will simply not appear in the
311 #       message.
312 #
313 #  '[id]=message-id'
314 #
315 #       Controls the message-id of the created message.
316 gen_msg_cnt=0
317 gen_msg_filename=""
318 gen_msg_id=""
319 generate_message ()
320 {
321     # This is our (bash-specific) magic for doing named parameters
322     local -A template="($@)"
323     local additional_headers
324
325     gen_msg_cnt=$((gen_msg_cnt + 1))
326     if [ -z "${template[filename]}" ]; then
327         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
328     else
329         gen_msg_name=${template[filename]}
330     fi
331
332     if [ -z "${template[id]}" ]; then
333         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
334     else
335         gen_msg_id="${template[id]}"
336     fi
337
338     if [ -z "${template[dir]}" ]; then
339         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
340     else
341         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
342         mkdir -p "$(dirname "$gen_msg_filename")"
343     fi
344
345     if [ -z "${template[body]}" ]; then
346         template[body]="This is just a test message (#${gen_msg_cnt})"
347     fi
348
349     if [ -z "${template[from]}" ]; then
350         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
351     fi
352
353     if [ -z "${template[to]}" ]; then
354         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
355     fi
356
357     if [ -z "${template[subject]}" ]; then
358         if [ -n "$test_subtest_name" ]; then
359             template[subject]="$test_subtest_name"
360         else
361             template[subject]="Test message #${gen_msg_cnt}"
362         fi
363     elif [ "${template[subject]}" = "@FORCE_EMPTY" ]; then
364         template[subject]=""
365     fi
366
367     if [ -z "${template[date]}" ]; then
368         # we use decreasing timestamps here for historical reasons;
369         # the existing test suite when we converted to unique timestamps just
370         # happened to have signicantly fewer failures with that choice.
371         local date_secs=$((978709437 - gen_msg_cnt))
372         # printf %(..)T is bash 4.2+ feature. use perl fallback if needed...
373         TZ=UTC printf -v template[date] "%(%a, %d %b %Y %T %z)T" $date_secs 2>/dev/null ||
374             template[date]=`perl -le 'use POSIX "strftime";
375                                 @time = gmtime '"$date_secs"';
376                                 print strftime "%a, %d %b %Y %T +0000", @time'`
377     fi
378
379     additional_headers=""
380     if [ ! -z "${template[header]}" ]; then
381         additional_headers="${template[header]}
382 ${additional_headers}"
383     fi
384
385     if [ ! -z "${template[reply-to]}" ]; then
386         additional_headers="Reply-To: ${template[reply-to]}
387 ${additional_headers}"
388     fi
389
390     if [ ! -z "${template[in-reply-to]}" ]; then
391         additional_headers="In-Reply-To: ${template[in-reply-to]}
392 ${additional_headers}"
393     fi
394
395     if [ ! -z "${template[cc]}" ]; then
396         additional_headers="Cc: ${template[cc]}
397 ${additional_headers}"
398     fi
399
400     if [ ! -z "${template[bcc]}" ]; then
401         additional_headers="Bcc: ${template[bcc]}
402 ${additional_headers}"
403     fi
404
405     if [ ! -z "${template[references]}" ]; then
406         additional_headers="References: ${template[references]}
407 ${additional_headers}"
408     fi
409
410     if [ ! -z "${template[content-type]}" ]; then
411         additional_headers="Content-Type: ${template[content-type]}
412 ${additional_headers}"
413     fi
414
415     if [ ! -z "${template[content-transfer-encoding]}" ]; then
416         additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
417 ${additional_headers}"
418     fi
419
420     # Note that in the way we're setting it above and using it below,
421     # `additional_headers' will also serve as the header / body separator
422     # (empty line in between).
423
424     cat <<EOF >"$gen_msg_filename"
425 From: ${template[from]}
426 To: ${template[to]}
427 Message-Id: <${gen_msg_id}>
428 Subject: ${template[subject]}
429 Date: ${template[date]}
430 ${additional_headers}
431 ${template[body]}
432 EOF
433 }
434
435 # Generate a new message and add it to the database.
436 #
437 # All of the arguments and return values supported by generate_message
438 # are also supported here, so see that function for details.
439 add_message ()
440 {
441     generate_message "$@" &&
442     notmuch new > /dev/null
443 }
444
445 # Deliver a message with emacs and add it to the database
446 #
447 # Uses emacs to generate and deliver a message to the mail store.
448 # Accepts arbitrary extra emacs/elisp functions to modify the message
449 # before sending, which is useful to doing things like attaching files
450 # to the message and encrypting/signing.
451 emacs_deliver_message ()
452 {
453     local subject="$1"
454     local body="$2"
455     shift 2
456     # before we can send a message, we have to prepare the FCC maildir
457     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
458     # eval'ing smtp-dummy --background will set smtp_dummy_pid
459     smtp_dummy_pid=
460     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
461     test -n "$smtp_dummy_pid" || return 1
462
463     test_emacs \
464         "(let ((message-send-mail-function 'message-smtpmail-send-it)
465                (mail-host-address \"example.com\")
466                (smtpmail-smtp-server \"localhost\")
467                (smtpmail-smtp-service \"25025\"))
468            (notmuch-mua-mail)
469            (message-goto-to)
470            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
471            (message-goto-subject)
472            (insert \"${subject}\")
473            (message-goto-body)
474            (insert \"${body}\")
475            $@
476            (notmuch-mua-send-and-exit))"
477
478     # In case message was sent properly, client waits for confirmation
479     # before exiting and resuming control here; therefore making sure
480     # that server exits by sending (KILL) signal to it is safe.
481     kill -9 $smtp_dummy_pid
482     notmuch new >/dev/null
483 }
484
485 # Pretend to deliver a message with emacs. Really save it to a file
486 # and add it to the database
487 #
488 # Uses emacs to generate and deliver a message to the mail store.
489 # Accepts arbitrary extra emacs/elisp functions to modify the message
490 # before sending, which is useful to doing things like attaching files
491 # to the message and encrypting/signing.
492 emacs_fcc_message ()
493 {
494     local subject="$1"
495     local body="$2"
496     shift 2
497     # before we can send a message, we have to prepare the FCC maildir
498     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
499
500     test_emacs \
501         "(let ((message-send-mail-function (lambda () t))
502                (mail-host-address \"example.com\"))
503            (notmuch-mua-mail)
504            (message-goto-to)
505            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
506            (message-goto-subject)
507            (insert \"${subject}\")
508            (message-goto-body)
509            (insert \"${body}\")
510            $@
511            (notmuch-mua-send-and-exit))" || return 1
512     notmuch new >/dev/null
513 }
514
515 # Add an existing, fixed corpus of email to the database.
516 #
517 # $1 is the corpus dir under corpora to add, using "default" if unset.
518 #
519 # The default corpus is based on about 50 messages from early in the
520 # history of the notmuch mailing list, which allows for reliably
521 # testing commands that need to operate on a not-totally-trivial
522 # number of messages.
523 add_email_corpus ()
524 {
525     corpus=${1:-default}
526
527     rm -rf ${MAIL_DIR}
528     if [ -d $TEST_DIRECTORY/corpora.mail/$corpus ]; then
529         cp -a $TEST_DIRECTORY/corpora.mail/$corpus ${MAIL_DIR}
530     else
531         cp -a $TEST_DIRECTORY/corpora/$corpus ${MAIL_DIR}
532         notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
533         mkdir -p $TEST_DIRECTORY/corpora.mail
534         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpora.mail/$corpus
535     fi
536 }
537
538 test_begin_subtest ()
539 {
540     if [ -n "$inside_subtest" ]; then
541         exec 1>&6 2>&7          # Restore stdout and stderr
542         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
543     fi
544     test_subtest_name="$1"
545     test_reset_state_
546     # Redirect test output to the previously prepared file descriptors
547     # 3 and 4 (see below)
548     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
549     exec >&3 2>&4
550     inside_subtest=t
551 }
552
553 # Pass test if two arguments match
554 #
555 # Note: Unlike all other test_expect_* functions, this function does
556 # not accept a test name. Instead, the caller should call
557 # test_begin_subtest before calling this function in order to set the
558 # name.
559 test_expect_equal ()
560 {
561         exec 1>&6 2>&7          # Restore stdout and stderr
562         inside_subtest=
563         test "$#" = 3 && { prereq=$1; shift; } || prereq=
564         test "$#" = 2 ||
565         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
566
567         output="$1"
568         expected="$2"
569         if ! test_skip "$test_subtest_name"
570         then
571                 if [ "$output" = "$expected" ]; then
572                         test_ok_
573                 else
574                         testname=$this_test.$test_count
575                         echo "$expected" > $testname.expected
576                         echo "$output" > $testname.output
577                         test_failure_ "$(diff -u $testname.expected $testname.output)"
578                 fi
579     fi
580 }
581
582 # Like test_expect_equal, but takes two filenames.
583 test_expect_equal_file ()
584 {
585         exec 1>&6 2>&7          # Restore stdout and stderr
586         inside_subtest=
587         test "$#" = 3 && { prereq=$1; shift; } || prereq=
588         test "$#" = 2 ||
589         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
590
591         file1="$1"
592         file2="$2"
593         if ! test_skip "$test_subtest_name"
594         then
595                 if diff -q "$file1" "$file2" >/dev/null ; then
596                         test_ok_
597                 else
598                         testname=$this_test.$test_count
599                         basename1=`basename "$file1"`
600                         basename2=`basename "$file2"`
601                         cp "$file1" "$testname.$basename1"
602                         cp "$file2" "$testname.$basename2"
603                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
604                 fi
605     fi
606 }
607
608 # Like test_expect_equal, but arguments are JSON expressions to be
609 # canonicalized before diff'ing.  If an argument cannot be parsed, it
610 # is used unchanged so that there's something to diff against.
611 test_expect_equal_json () {
612     # The test suite forces LC_ALL=C, but this causes Python 3 to
613     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
614     # override Python's stdio encoding defaults.
615     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -mjson.tool \
616         || echo "$1")
617     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -mjson.tool \
618         || echo "$2")
619     shift 2
620     test_expect_equal "$output" "$expected" "$@"
621 }
622
623 # Sort the top-level list of JSON data from stdin.
624 test_sort_json () {
625     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
626         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
627 }
628
629 test_emacs_expect_t () {
630         test "$#" = 2 && { prereq=$1; shift; } || prereq=
631         test "$#" = 1 ||
632         error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
633
634         # Run the test.
635         if ! test_skip "$test_subtest_name"
636         then
637                 test_emacs "(notmuch-test-run $1)" >/dev/null
638
639                 # Restore state after the test.
640                 exec 1>&6 2>&7          # Restore stdout and stderr
641                 inside_subtest=
642
643                 # Report success/failure.
644                 result=$(cat OUTPUT)
645                 if [ "$result" = t ]
646                 then
647                         test_ok_
648                 else
649                         test_failure_ "${result}"
650                 fi
651         else
652                 # Restore state after the (non) test.
653                 exec 1>&6 2>&7          # Restore stdout and stderr
654                 inside_subtest=
655         fi
656 }
657
658 NOTMUCH_NEW ()
659 {
660     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
661 }
662
663 NOTMUCH_DUMP_TAGS ()
664 {
665     # this relies on the default format being batch-tag, otherwise some tests will break
666     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
667 }
668
669 notmuch_search_sanitize ()
670 {
671     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
672 }
673
674 notmuch_search_files_sanitize ()
675 {
676     notmuch_dir_sanitize
677 }
678
679 notmuch_dir_sanitize ()
680 {
681     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
682 }
683
684 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
685 notmuch_show_sanitize ()
686 {
687     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
688 }
689 notmuch_show_sanitize_all ()
690 {
691     sed \
692         -e 's| filename:.*| filename:XXXXX|' \
693         -e 's| id:[^ ]* | id:XXXXX |' | \
694         notmuch_date_sanitize
695 }
696
697 notmuch_json_show_sanitize ()
698 {
699     sed \
700         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
701         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
702         -e 's|"filename": "signature.asc",||g' \
703         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
704         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
705         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
706 }
707
708 notmuch_emacs_error_sanitize ()
709 {
710     local command=$1
711     shift
712     for file in "$@"; do
713         echo "=== $file ==="
714         cat "$file"
715     done | sed  \
716         -e 's/^\[.*\]$/[XXX]/' \
717         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
718 }
719
720 notmuch_date_sanitize ()
721 {
722     sed \
723         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
724 }
725
726 notmuch_uuid_sanitize ()
727 {
728     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
729 }
730
731 notmuch_built_with_sanitize ()
732 {
733     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
734 }
735
736 notmuch_config_sanitize ()
737 {
738     notmuch_dir_sanitize | notmuch_built_with_sanitize
739 }
740
741 # End of notmuch helper functions
742
743 # Use test_set_prereq to tell that a particular prerequisite is available.
744 # The prerequisite can later be checked for in two ways:
745 #
746 # - Explicitly using test_have_prereq.
747 #
748 # - Implicitly by specifying the prerequisite tag in the calls to
749 #   test_expect_{success,failure,code}.
750 #
751 # The single parameter is the prerequisite tag (a simple word, in all
752 # capital letters by convention).
753
754 test_set_prereq () {
755         satisfied="$satisfied$1 "
756 }
757 satisfied=" "
758
759 test_have_prereq () {
760         case $satisfied in
761         *" $1 "*)
762                 : yes, have it ;;
763         *)
764                 ! : nope ;;
765         esac
766 }
767
768 declare -A test_missing_external_prereq_
769 declare -A test_subtest_missing_external_prereq_
770
771 # declare prerequisite for the given external binary
772 test_declare_external_prereq () {
773         binary="$1"
774         test "$#" = 2 && name=$2 || name="$binary(1)"
775
776         if ! hash $binary 2>/dev/null; then
777                 test_missing_external_prereq_["${binary}"]=t
778                 eval "
779 $binary () {
780         test_subtest_missing_external_prereq_[\"${name}\"]=t
781         false
782 }"
783         fi
784 }
785
786 # Explicitly require external prerequisite.  Useful when binary is
787 # called indirectly (e.g. from emacs).
788 # Returns success if dependency is available, failure otherwise.
789 test_require_external_prereq () {
790         binary="$1"
791         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
792                 # dependency is missing, call the replacement function to note it
793                 eval "$binary"
794         else
795                 true
796         fi
797 }
798
799 # You are not expected to call test_ok_ and test_failure_ directly, use
800 # the text_expect_* functions instead.
801
802 test_ok_ () {
803         if test "$test_subtest_known_broken_" = "t"; then
804                 test_known_broken_ok_
805                 return
806         fi
807         test_success=$(($test_success + 1))
808         if test -n "$NOTMUCH_TEST_QUIET"; then
809                 return 0
810         fi
811         say_color pass "%-6s" "PASS"
812         echo " $test_subtest_name"
813 }
814
815 test_failure_ () {
816         print_test_description
817         if test "$test_subtest_known_broken_" = "t"; then
818                 test_known_broken_failure_ "$@"
819                 return
820         fi
821         test_failure=$(($test_failure + 1))
822         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
823         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
824         return 1
825 }
826
827 test_failure_message_ () {
828         say_color error "%-6s" "$1"
829         echo " $2"
830         shift 2
831         if [ "$#" != "0" ]; then
832                 echo "$@" | sed -e 's/^/        /'
833         fi
834         if test "$verbose" != "t"; then cat test.output; fi
835 }
836
837 test_known_broken_ok_ () {
838         test_reset_state_
839         test_fixed=$(($test_fixed+1))
840         say_color pass "%-6s" "FIXED"
841         echo " $test_subtest_name"
842 }
843
844 test_known_broken_failure_ () {
845         test_reset_state_
846         test_broken=$(($test_broken+1))
847         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
848                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
849         else
850                 test_failure_message_ "BROKEN" "$test_subtest_name"
851         fi
852         return 1
853 }
854
855 test_debug () {
856         test "$debug" = "" || eval "$1"
857 }
858
859 test_run_ () {
860         test_cleanup=:
861         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
862         eval >&3 2>&4 "$1"
863         eval_ret=$?
864         eval >&3 2>&4 "$test_cleanup"
865         return 0
866 }
867
868 test_skip () {
869         test_count=$(($test_count+1))
870         to_skip=
871         for skp in $NOTMUCH_SKIP_TESTS
872         do
873                 case $this_test.$test_count in
874                 $skp)
875                         to_skip=t
876                         break
877                 esac
878                 case $this_test_bare.$test_count in
879                 $skp)
880                         to_skip=t
881                         break
882                 esac
883         done
884         if test -z "$to_skip" && test -n "$prereq" &&
885            ! test_have_prereq "$prereq"
886         then
887                 to_skip=t
888         fi
889         case "$to_skip" in
890         t)
891                 test_report_skip_ "$@"
892                 ;;
893         *)
894                 test_check_missing_external_prereqs_ "$@"
895                 ;;
896         esac
897 }
898
899 test_check_missing_external_prereqs_ () {
900         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
901                 say_color skip >&1 "missing prerequisites: "
902                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
903                 test_report_skip_ "$@"
904         else
905                 false
906         fi
907 }
908
909 test_report_skip_ () {
910         test_reset_state_
911         say_color skip >&3 "skipping test:"
912         echo " $@" >&3
913         say_color skip "%-6s" "SKIP"
914         echo " $1"
915 }
916
917 test_subtest_known_broken () {
918         test_subtest_known_broken_=t
919 }
920
921 test_expect_success () {
922         test "$#" = 3 && { prereq=$1; shift; } || prereq=
923         test "$#" = 2 ||
924         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
925         test_subtest_name="$1"
926         test_reset_state_
927         if ! test_skip "$@"
928         then
929                 test_run_ "$2"
930                 run_ret="$?"
931                 # test_run_ may update missing external prerequisites
932                 test_check_missing_external_prereqs_ "$@" ||
933                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
934                 then
935                         test_ok_
936                 else
937                         test_failure_ "$2"
938                 fi
939         fi
940 }
941
942 test_expect_code () {
943         test "$#" = 4 && { prereq=$1; shift; } || prereq=
944         test "$#" = 3 ||
945         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
946         test_subtest_name="$2"
947         test_reset_state_
948         if ! test_skip "$@"
949         then
950                 test_run_ "$3"
951                 run_ret="$?"
952                 # test_run_ may update missing external prerequisites,
953                 test_check_missing_external_prereqs_ "$@" ||
954                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
955                 then
956                         test_ok_
957                 else
958                         test_failure_ "exit code $eval_ret, expected $1" "$3"
959                 fi
960         fi
961 }
962
963 # This is not among top-level (test_expect_success)
964 # but is a prefix that can be used in the test script, like:
965 #
966 #       test_expect_success 'complain and die' '
967 #           do something &&
968 #           do something else &&
969 #           test_must_fail git checkout ../outerspace
970 #       '
971 #
972 # Writing this as "! git checkout ../outerspace" is wrong, because
973 # the failure could be due to a segv.  We want a controlled failure.
974
975 test_must_fail () {
976         "$@"
977         test $? -gt 0 -a $? -le 129 -o $? -gt 192
978 }
979
980 # test_cmp is a helper function to compare actual and expected output.
981 # You can use it like:
982 #
983 #       test_expect_success 'foo works' '
984 #               echo expected >expected &&
985 #               foo >actual &&
986 #               test_cmp expected actual
987 #       '
988 #
989 # This could be written as either "cmp" or "diff -u", but:
990 # - cmp's output is not nearly as easy to read as diff -u
991 # - not all diff versions understand "-u"
992
993 test_cmp() {
994         $GIT_TEST_CMP "$@"
995 }
996
997 # This function can be used to schedule some commands to be run
998 # unconditionally at the end of the test to restore sanity:
999 #
1000 #       test_expect_success 'test core.capslock' '
1001 #               git config core.capslock true &&
1002 #               test_when_finished "git config --unset core.capslock" &&
1003 #               hello world
1004 #       '
1005 #
1006 # That would be roughly equivalent to
1007 #
1008 #       test_expect_success 'test core.capslock' '
1009 #               git config core.capslock true &&
1010 #               hello world
1011 #               git config --unset core.capslock
1012 #       '
1013 #
1014 # except that the greeting and config --unset must both succeed for
1015 # the test to pass.
1016
1017 test_when_finished () {
1018         test_cleanup="{ $*
1019                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1020 }
1021
1022 test_done () {
1023         GIT_EXIT_OK=t
1024         test_results_dir="$TEST_DIRECTORY/test-results"
1025         mkdir -p "$test_results_dir"
1026         test_results_path="$test_results_dir/$this_test"
1027
1028         echo "total $test_count" >> $test_results_path
1029         echo "success $test_success" >> $test_results_path
1030         echo "fixed $test_fixed" >> $test_results_path
1031         echo "broken $test_broken" >> $test_results_path
1032         echo "failed $test_failure" >> $test_results_path
1033         echo "" >> $test_results_path
1034
1035         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
1036
1037         if [ "$test_failure" = "0" ]; then
1038             if [ "$test_broken" = "0" ]; then
1039                 rm -rf "$remove_tmp"
1040             fi
1041             exit 0
1042         else
1043             exit 1
1044         fi
1045 }
1046
1047 emacs_generate_script () {
1048         # Construct a little test script here for the benefit of the user,
1049         # (who can easily run "run_emacs" to get the same emacs environment
1050         # for investigating any failures).
1051         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1052 #!/bin/sh
1053 export PATH=$PATH
1054 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1055
1056 # Here's what we are using here:
1057 #
1058 # --quick              Use minimal customization. This implies --no-init-file,
1059 #                      --no-site-file and (emacs 24) --no-site-lisp
1060 #
1061 # --directory           Ensure that the local elisp sources are found
1062 #
1063 # --load                Force loading of notmuch.el and test-lib.el
1064
1065 exec ${TEST_EMACS} --quick \
1066         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
1067         --directory "$TEST_DIRECTORY" --load test-lib.el \
1068         "\$@"
1069 EOF
1070         chmod a+x "$TMP_DIRECTORY/run_emacs"
1071 }
1072
1073 test_emacs () {
1074         # test dependencies beforehand to avoid the waiting loop below
1075         missing_dependencies=
1076         test_require_external_prereq dtach || missing_dependencies=1
1077         test_require_external_prereq emacs || missing_dependencies=1
1078         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1079         test -z "$missing_dependencies" || return
1080
1081         if [ -z "$EMACS_SERVER" ]; then
1082                 emacs_tests="${this_test_bare}.el"
1083                 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
1084                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1085                 else
1086                         load_emacs_tests=
1087                 fi
1088                 server_name="notmuch-test-suite-$$"
1089                 # start a detached session with an emacs server
1090                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1091                 # or unknown) is given to dtach which assumes a minimally
1092                 # VT100-compatible terminal -- and emacs inherits that
1093                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1094                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1095                                 --no-window-system \
1096                                 $load_emacs_tests \
1097                                 --eval '(setq server-name \"$server_name\")' \
1098                                 --eval '(server-start)' \
1099                                 --eval '(orphan-watchdog $$)'" || return
1100                 EMACS_SERVER="$server_name"
1101                 # wait until the emacs server is up
1102                 until test_emacs '()' >/dev/null 2>/dev/null; do
1103                         sleep 1
1104                 done
1105         fi
1106
1107         # Clear test-output output file.  Most Emacs tests end with a
1108         # call to (test-output).  If the test code fails with an
1109         # exception before this call, the output file won't get
1110         # updated.  Since we don't want to compare against an output
1111         # file from another test, so start out with an empty file.
1112         rm -f OUTPUT
1113         touch OUTPUT
1114
1115         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $@)"
1116 }
1117
1118 test_python() {
1119     # Note: if there is need to print debug information from python program,
1120     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1121     PYTHONPATH="$TEST_DIRECTORY/../bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1122         $NOTMUCH_PYTHON -B - > OUTPUT
1123 }
1124
1125 test_ruby() {
1126     MAIL_DIR=$MAIL_DIR ruby -I $TEST_DIRECTORY/../bindings/ruby> OUTPUT
1127 }
1128
1129 test_C () {
1130     exec_file="test${test_count}"
1131     test_file="${exec_file}.c"
1132     cat > ${test_file}
1133     ${TEST_CC} ${TEST_CFLAGS} -I${TEST_DIRECTORY} -I${TEST_DIRECTORY}/../lib -o ${exec_file} ${test_file} -L${TEST_DIRECTORY}/../lib/ -lnotmuch -ltalloc
1134     echo "== stdout ==" > OUTPUT.stdout
1135     echo "== stderr ==" > OUTPUT.stderr
1136     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1137     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1138 }
1139
1140
1141 # Creates a script that counts how much time it is executed and calls
1142 # notmuch.  $notmuch_counter_command is set to the path to the
1143 # generated script.  Use notmuch_counter_value() function to get the
1144 # current counter value.
1145 notmuch_counter_reset () {
1146         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1147         if [ ! -x "$notmuch_counter_command" ]; then
1148                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1149                 cat >"$notmuch_counter_command" <<EOF || return
1150 #!/bin/sh
1151
1152 read count < "$notmuch_counter_state_path"
1153 echo \$((count + 1)) > "$notmuch_counter_state_path"
1154
1155 exec notmuch "\$@"
1156 EOF
1157                 chmod +x "$notmuch_counter_command" || return
1158         fi
1159
1160         echo 0 > "$notmuch_counter_state_path"
1161 }
1162
1163 # Returns the current notmuch counter value.
1164 notmuch_counter_value () {
1165         if [ -r "$notmuch_counter_state_path" ]; then
1166                 read count < "$notmuch_counter_state_path"
1167         else
1168                 count=0
1169         fi
1170         echo $count
1171 }
1172
1173 test_reset_state_ () {
1174         test -z "$test_init_done_" && test_init_
1175
1176         test_subtest_known_broken_=
1177         test_subtest_missing_external_prereq_=()
1178 }
1179
1180 # called once before the first subtest
1181 test_init_ () {
1182         test_init_done_=t
1183
1184         # skip all tests if there were external prerequisites missing during init
1185         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1186 }
1187
1188
1189 . ./test-lib-common.sh || exit 1
1190
1191 emacs_generate_script
1192
1193
1194 # Use -P to resolve symlinks in our working directory so that the cwd
1195 # in subprocesses like git equals our $PWD (for pathname comparisons).
1196 cd -P "$test" || error "Cannot set up test environment"
1197
1198 if test "$verbose" = "t"
1199 then
1200         exec 4>&2 3>&1
1201 else
1202         exec 4>test.output 3>&4
1203 fi
1204
1205 for skp in $NOTMUCH_SKIP_TESTS
1206 do
1207         to_skip=
1208         for skp in $NOTMUCH_SKIP_TESTS
1209         do
1210                 case "$this_test" in
1211                 $skp)
1212                         to_skip=t
1213                         break
1214                 esac
1215                 case "$this_test_bare" in
1216                 $skp)
1217                         to_skip=t
1218                         break
1219                 esac
1220         done
1221         case "$to_skip" in
1222         t)
1223                 say_color skip >&3 "skipping test $this_test altogether"
1224                 say_color skip "skip all tests in $this_test"
1225                 test_done
1226         esac
1227 done
1228
1229 # Provide an implementation of the 'yes' utility
1230 yes () {
1231         if test $# = 0
1232         then
1233                 y=y
1234         else
1235                 y="$*"
1236         fi
1237
1238         while echo "$y"
1239         do
1240                 :
1241         done
1242 }
1243
1244 # Fix some commands on Windows
1245 case $(uname -s) in
1246 *MINGW*)
1247         # Windows has its own (incompatible) sort and find
1248         sort () {
1249                 /usr/bin/sort "$@"
1250         }
1251         find () {
1252                 /usr/bin/find "$@"
1253         }
1254         sum () {
1255                 md5sum "$@"
1256         }
1257         # git sees Windows-style pwd
1258         pwd () {
1259                 builtin pwd -W
1260         }
1261         # no POSIX permissions
1262         # backslashes in pathspec are converted to '/'
1263         # exec does not inherit the PID
1264         ;;
1265 *)
1266         test_set_prereq POSIXPERM
1267         test_set_prereq BSLASHPSPEC
1268         test_set_prereq EXECKEEPSPID
1269         ;;
1270 esac
1271
1272 test -z "$NO_PERL" && test_set_prereq PERL
1273 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1274
1275 # test whether the filesystem supports symbolic links
1276 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1277 rm -f y
1278
1279 # convert variable from configure to more convenient form
1280 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1281     glass)
1282         db_ending=glass
1283     ;;
1284     chert)
1285         db_ending=DB
1286     ;;
1287     *)
1288         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1289 esac
1290 # declare prerequisites for external binaries used in tests
1291 test_declare_external_prereq dtach
1292 test_declare_external_prereq emacs
1293 test_declare_external_prereq ${TEST_EMACSCLIENT}
1294 test_declare_external_prereq ${TEST_GDB}
1295 test_declare_external_prereq gpg
1296 test_declare_external_prereq openssl
1297 test_declare_external_prereq gpgsm
1298 test_declare_external_prereq ${NOTMUCH_PYTHON}